Updates to the build farm tests:
[ira/wip.git] / testsuite / build_farm / basicsmb.fns
1 #! /bin/sh
2
3 # Common functions for Samba build scripts.
4
5 # Copyright (C) 2001 by Martin Pool <mbp@samba.org> and others
6
7 # The following variables are passed in by the calling script.  They
8 # originate in either the buildfarm scripts or the configured
9 # Makefile.
10
11 # PREFIX = Installed prefix of samba test installation.  Used to
12 # locate binaries, configuration files, etc.  
13
14 # XXX: It's pretty bad to clobber the installed configuration file and
15 # other data in $prefix, because somebody might unwittingly run this
16 # with prefix=/usr.  
17
18 # Really what we want is a consistent way to pass the location of the
19 # configuration and all other files into *all* Samba programs
20 # (smbclient, smd, ...) and be able to set them to a temporary
21 # directory when testing.  Some of them take a -c parameter, but tpot
22 # says it's not done consistently.
23
24 template_setup() {
25         cat $1.template | \
26               sed "s|PREFIX|$prefix|g" | \
27               sed "s|BUILD_FARM|$test_root|g" | \
28               sed "s|WHOAMI|$whoami|g" | \
29               sed "s|LOGLEVEL|$loglevel|g" \
30         > $prefix/$2
31         echo "template_setup: Created $prefix/$2"
32 }
33
34 template_smb_conf_setup() {
35     template_setup "basicsmb.smb.conf$1" "lib/smb.conf$1"
36 }
37
38 test_smb_conf_setup() {
39     echo "test_smb_conf_setup: Configuring: "
40     echo "    PREFIX=$prefix"
41     echo "    BUILD_FARM=$test_root"
42     echo "    WHOAMI=$whoami"
43     echo "    LOGLEVEL=$loglevel"
44     echo "    TREE=$tree"
45
46     case "$prefix" in
47     /usr*|/|//)
48         echo "** I don't want to clobber your installation in "
49         echo "**     $prefix"
50         echo "** by running tests there.  Please reconfigure this source tree to"
51         echo "** use a different prefix."
52         exit 1
53     esac
54
55     template_smb_conf_setup 
56     template_smb_conf_setup .hostsequiv
57     template_smb_conf_setup .validusers
58     template_smb_conf_setup .invalidusers
59     template_smb_conf_setup .preexec
60     template_smb_conf_setup .preexec_close
61     template_smb_conf_setup .preexec_cl_fail
62
63     template_setup preexec lib/preexec
64
65         echo "127.0.0.1    localhost">$prefix/lib/lmhosts
66         echo "127.0.0.2    BUILDFARM">>$prefix/lib/lmhosts
67     echo "127.0.0.3    SHARE">>$prefix/lib/lmhosts
68     echo "127.0.0.4    USER">>$prefix/lib/lmhosts
69     echo "127.0.0.5    SERVER">>$prefix/lib/lmhosts
70     echo "127.0.0.6    DOMAIN">>$prefix/lib/lmhosts
71     echo "127.0.0.7    HOSTSEQUIV">>$prefix/lib/lmhosts
72     echo "127.0.0.7    VALIDUSERS">>$prefix/lib/lmhosts
73     echo "127.0.0.7    INVALIDUSERS">>$prefix/lib/lmhosts
74     echo "127.0.0.7    PREEXEC">>$prefix/lib/lmhosts
75     echo "127.0.0.7    PREEXEC_CLOSE">>$prefix/lib/lmhosts
76     echo "127.0.0.7    PREEXEC_CL_FAIL">>$prefix/lib/lmhosts
77
78
79         echo "127.0.0.1" > $prefix/lib/hosts.equiv
80
81     cp basicsmb.smb.conf.share $prefix/lib/smb.conf.share
82     cp basicsmb.smb.conf.user $prefix/lib/smb.conf.user
83     cp basicsmb.smb.conf.server $prefix/lib/smb.conf.server
84     cp basicsmb.smb.conf.domain $prefix/lib/smb.conf.domain
85
86     touch $prefix/lib/smb.conf.
87     touch $prefix/lib/smb.conf.localhost
88 }
89
90 test_smbpasswd() {
91         test_smbpasswd_password="$1"
92         rm -f $prefix/private/smbpasswd
93         echo "( echo $test_smbpasswd_password ; echo $test_smbpasswd_password; ) | $prefix/bin/smbpasswd -L -s -a $whoami"
94         ( echo $test_smbpasswd_password; echo $test_smbpasswd_password; ) | $prefix/bin/smbpasswd -L -s -a $whoami
95         status=$?
96         if [ $status = 0 ]; then
97             echo "smbpasswd correctly set initial password ($test_smbpasswd_password)"
98         else
99             echo "smbpasswd failed to set initial password ($test_smbpasswd_password)! (status $status)"
100             return 1
101         fi
102         return 0
103 }
104
105 test_smbpasswd_remote() {
106         test_smbpasswd_rem_password="$1"
107         test_smbpasswd_rem_newpassword="$2"
108         echo "( echo $test_smbpasswd_rem_password; echo $test_smbpasswd_rem_newpassword; echo $test_smbpasswd_rem_newpassword; ) | $prefix/bin/smbpasswd -r localhost -s -U $whoami"
109         ( echo $test_smbpasswd_rem_password; echo $test_smbpasswd_rem_newpassword; echo $test_smbpasswd_rem_newpassword; ) | $prefix/bin/smbpasswd -r localhost -s -U $whoami
110         status=$?
111         if [ $status = 0 ]; then
112             echo "smbpasswd correctly remotely changed password ($test_smbpasswd_rem_password -> $test_smbpasswd_rem_newpassword)"
113         else
114             echo "smbpasswd failed to remotely changed password ($test_smbpasswd_rem_password -> $test_smbpasswd_rem_newpassword)! (status $status)"
115             return 1
116         fi
117         return 0
118 }
119
120 test_smbpasswd_local() {
121         test_smbpasswd_newpassword="$2"
122         echo "( echo $test_smbpasswd_newpassword ; echo $test_smbpasswd_newpassword; ) | $prefix/bin/smbpasswd -L -s $whoami"
123         ( echo $test_smbpasswd_newpassword ; echo $test_smbpasswd_newpassword; ) | $prefix/bin/smbpasswd -L -s $whoami
124         status=$?
125         if [ $status = 0 ]; then
126             echo "smbpasswd correctly locally changed password ($test_smbpasswd_password -> $test_smbpasswd_newpassword)"
127         else
128             echo "smbpasswd failed to locallly changed password ($test_smbpasswd_password -> $test_smbpasswd_newpassword)! (status $status)"
129             return 1
130         fi
131         return 0
132 }
133
134 test_listfilesauth() {
135         remote_name="$1"
136         echo $prefix/bin/smbclient //$remote_name/samba  -n buildclient -U$whoami%$password -c 'ls'
137         $prefix/bin/smbclient //$remote_name/samba  -n buildclient -U$whoami%$password -c 'ls'
138         status=$?
139         if [ $status = 0 ]; then
140                 echo "listed files OK"
141         else 
142                 echo "listing files with smbd failed with status $status"
143                 return 1
144         fi
145         return 0
146 }
147
148 test_listfilesnpw() {
149         remote_name="$1"
150         echo $prefix/bin/smbclient //$remote_name/samba -n buildclient -U$whoami%  -c 'ls'
151         $prefix/bin/smbclient //$remote_name/samba -n buildclient -U$whoami% -c 'ls'
152         status=$?
153         if [ $status = 0 ]; then
154                 echo "smbd listed files with NO PASSWORD on an authenticated share!"
155                 return 1
156         else 
157                 echo "listing files with smbd failed with status $status (correct)"
158         fi
159         return 0
160 }
161
162 test_listfilesauth_should_deny() {
163         remote_name="$1"
164         echo $prefix/bin/smbclient //$remote_name/samba -n buildclient -U$whoami%$password  -c 'ls'
165         $prefix/bin/smbclient //$remote_name/samba -n buildclient -U$whoami%$password -c 'ls'
166         status=$?
167         if [ $status = 0 ]; then
168                 echo "smbd LISTED FILES despite smb.conf entires to the contary!"
169                 return 1
170         else 
171                 echo "listing files with smbd failed with status $status (correct)"
172         fi
173         return 0
174 }
175
176 echo "LIBSMB_PROG=$LIBSMB_PROG" >&2
177
178
179
180 # Give sensible defaults to some variables.  
181
182 # "What's my age again?"
183
184 if [ ! $USER = "" ]; then
185     whoami=$USER
186 else 
187     if [ ! $LOGNAME = "" ]; then
188         whoami=$LOGNAME
189     else
190         whoami=build
191     fi
192 fi
193
194
195
196 if test -z "$loglevel"
197 then
198     loglevel=1
199 fi
200